package sssss.config;

import java.io.IOException;

import javax.annotation.Resource;
import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.annotation.WebFilter;
import javax.servlet.http.HttpServletRequest;

import org.springframework.stereotype.Component;

import sssss.model.AccountInfo;
import sssss.service.AccountService;
import sssss.utils.MyUtils;

import net.sf.json.JSONObject;
 
/**
 * 过滤器
 * 用来过滤请求
 * 校验用户Authorization，即token
 */
@Component
@WebFilter(urlPatterns = "/*")
public class MyFilter implements Filter {
 
	@Resource
	private AccountService accountService;
    
 
    @Override
    public void init(FilterConfig filterConfig) throws ServletException {
 
    }
 
    @Override
    public void doFilter(ServletRequest request, ServletResponse response, FilterChain chain) throws IOException, ServletException {

        HttpServletRequest req = (HttpServletRequest) request;
 
        //放行 options 的请求
        if ("OPTIONS".equals(req.getMethod())) {
        	chain.doFilter(req, response);
        }else {
        	/**
             * 若存在authorization则解析，并返回参数
             * 否则，滤过，等到拦截器再次校验
             */
    		String authorization = req.getHeader("Authorization");
            if(MyUtils.isNotNull(authorization)) {
                ParameterRequestWrapper  wrapRequest = new ParameterRequestWrapper (req);
    			
				//解析成功之后，将数据返回给params
	            AccountInfo info =  accountService.resolveAccount(authorization);
	            String params1 = req.getParameter("params");

	            String params = wrapRequest.getParameter("params");
	            if(MyUtils.isNotNull(params)) {
	            	 JSONObject json = MyUtils.fromJson(params, JSONObject.class);
	 	            json.put("accountInfo", MyUtils.toJson(info));
	 	            wrapRequest.putParameterValues("params", MyUtils.toJson(json));
	            }
	           
    			
    	        chain.doFilter(wrapRequest, response);
            }else {
                chain.doFilter(request, response);
            }
        }
    }
 
 
    @Override
    public void destroy() {
 
    }
}
